Index: /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90
===================================================================
--- /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 2231)
+++ /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 2232)
@@ -467,34 +871,226 @@
 ! ------------
 !> Compute the absolute value of the horizontal velocity (relative to the
-!> surface). This is required by all methods
+!> surface) for horizontal surface elements. This is required by all methods.
 !------------------------------------------------------------------------------!
-    SUBROUTINE calc_uv_total
+    SUBROUTINE calc_uvw_abs
 
        IMPLICIT NONE
 
-
-       !$OMP PARALLEL DO PRIVATE( k )
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-
-             k   = nzb_s_inner(j,i)
-             uv_total(j,i) = SQRT( ( 0.5_wp * ( u(k+1,j,i) + u(k+1,j,i+1)      &
-                                         - u(k,j,i)   - u(k,j,i+1) ) )**2 +    &
-                              ( 0.5_wp * ( v(k+1,j,i) + v(k+1,j+1,i)           &
-                                         - v(k,j,i)   - v(k,j+1,i) ) )**2 )
-
-!
-!--          For too small values of the local wind, MOST does not work. A
-!--          threshold value is thus set if required
-!            uv_total(j,i) = MAX(0.01_wp,uv_total(j,i))
-
+       INTEGER(iwp) ::  i             !< running index x direction
+       INTEGER(iwp) ::  ibit          !< flag to mask computation of relative velocity in case of downward-facing surfaces
+       INTEGER(iwp) ::  j             !< running index y direction
+       INTEGER(iwp) ::  k             !< running index z direction
+       INTEGER(iwp) ::  m             !< running index surface elements
+
+!
+!--    ibit is 1 for upward-facing surfaces, zero for downward-facing surfaces.
+       ibit = MERGE( 1, 0, .NOT. downward )
+
+       DO  m = 1, surf%ns
+
+          i   = surf%i(m)            
+          j   = surf%j(m)
+          k   = surf%k(m)
+!
+!--       Compute the absolute value of the horizontal velocity.
+!--       (relative to the surface in case the lower surface is the ocean).
+!--       Please note, in new surface modelling concept the index values changed,
+!--       i.e. the reference grid point is not the surface-grid point itself but
+!--       the first grid point outside of the topography. 
+!--       Note, in case of coupled ocean-atmosphere simulations relative velocity
+!--       with respect to the ocean surface is used, hence, (k-1,j,i) values
+!--       are used to calculate the absolute velocity. 
+!--       However, this do not apply for downward-facing walls. To mask this, 
+!--       use ibit, which checks for upward/downward-facing surfaces. 
+
+          surf%uvw_abs(m) = SQRT(                                              &
+                              ( 0.5_wp * (   u(k,j,i)   + u(k,j,i+1)           &
+                                        -  ( u(k-1,j,i) + u(k-1,j,i+1)         &
+                                           ) * ibit                            &
+                                         )                                     &
+                              )**2 +                                           &
+                              ( 0.5_wp * (   v(k,j,i)   + v(k,j+1,i)           &
+                                        -  ( v(k-1,j,i) + v(k-1,j+1,i)         &
+                                           ) * ibit                            &
+                                         )                                     &
+                              )**2                                             &
+                                )
+
+       ENDDO
+
+    END SUBROUTINE calc_uvw_abs
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Compute the absolute value of the horizontal velocity (relative to the
+!> surface) for horizontal surface elements. This is required by all methods.
+!------------------------------------------------------------------------------!
+    SUBROUTINE calc_uvw_abs_v_ugrid
+
+       IMPLICIT NONE
+
+       INTEGER(iwp) ::  i             !< running index x direction
+       INTEGER(iwp) ::  j             !< running index y direction
+       INTEGER(iwp) ::  k             !< running index z direction
+       INTEGER(iwp) ::  m             !< running index surface elements
+
+       REAL(wp)     ::  u_i
+       REAL(wp)     ::  w_i
+
+
+       DO  m = 1, surf%ns
+          i   = surf%i(m)            
+          j   = surf%j(m)
+          k   = surf%k(m)
+!
+!--       Compute the absolute value of the surface parallel velocity on u-grid.
+          u_i  = u(k,j,i)
+          w_i  = 0.25_wp * ( w(k-1,j,i-1) + w(k-1,j,i) +                       &
+                             w(k,j,i-1)   + w(k,j,i) ) 
+
+          surf%uvw_abs(m) = SQRT( u_i**2 + w_i**2 ) 
+
+       ENDDO
+
+    END SUBROUTINE calc_uvw_abs_v_ugrid
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Compute the absolute value of the horizontal velocity (relative to the
+!> surface) for horizontal surface elements. This is required by all methods.
+!------------------------------------------------------------------------------!
+    SUBROUTINE calc_uvw_abs_v_vgrid
+
+       IMPLICIT NONE
+
+       INTEGER(iwp) ::  i             !< running index x direction
+       INTEGER(iwp) ::  j             !< running index y direction
+       INTEGER(iwp) ::  k             !< running index z direction
+       INTEGER(iwp) ::  m             !< running index surface elements
+
+       REAL(wp)     ::  v_i
+       REAL(wp)     ::  w_i
+
+
+       DO  m = 1, surf%ns
+          i   = surf%i(m)            
+          j   = surf%j(m)
+          k   = surf%k(m)
+
+          v_i  = u(k,j,i)
+          w_i  = 0.25_wp * ( w(k-1,j-1,i) + w(k-1,j,i) +                       &
+                             w(k,j-1,i)   + w(k,j,i) ) 
+
+          surf%uvw_abs(m) = SQRT( v_i**2 + w_i**2 ) 
+
+       ENDDO
+
+    END SUBROUTINE calc_uvw_abs_v_vgrid
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Compute the absolute value of the horizontal velocity (relative to the
+!> surface) for horizontal surface elements. This is required by all methods.
+!------------------------------------------------------------------------------!
+    SUBROUTINE calc_uvw_abs_v_wgrid
+
+       IMPLICIT NONE
+
+       INTEGER(iwp) ::  i             !< running index x direction
+       INTEGER(iwp) ::  j             !< running index y direction
+       INTEGER(iwp) ::  k             !< running index z direction
+       INTEGER(iwp) ::  m             !< running index surface elements
+
+       REAL(wp)     ::  u_i
+       REAL(wp)     ::  v_i
+       REAL(wp)     ::  w_i
+!
+!--    North- (l=0) and south-facing (l=1) surfaces 
+       IF ( l == 0  .OR.  l == 1 )  THEN
+          DO  m = 1, surf%ns
+             i   = surf%i(m)            
+             j   = surf%j(m)
+             k   = surf%k(m)
+
+             u_i  = 0.25_wp * ( u(k+1,j,i+1) + u(k+1,j,i) +                    &
+                                u(k,j,i+1)   + u(k,j,i) )
+             v_i  = 0.0_wp
+             w_i  = w(k,j,i)
+
+             surf%uvw_abs(m) = SQRT( u_i**2 + v_i**2 + w_i**2 ) 
           ENDDO
-       ENDDO
-
-!
-!--    Values of uv_total need to be exchanged at the ghost boundaries
-       CALL exchange_horiz_2d( uv_total )
-
-    END SUBROUTINE calc_uv_total
+!
+!--    East- (l=2) and west-facing (l=3) surfaces
+       ELSE
+          DO  m = 1, surf%ns
+             i   = surf%i(m)            
+             j   = surf%j(m)
+             k   = surf%k(m)
+
+             u_i  = 0.0_wp
+             v_i  = 0.25_wp * ( v(k+1,j+1,i) + v(k+1,j,i) +                    &
+                                v(k,j+1,i)   + v(k,j,i) )
+             w_i  = w(k,j,i)
+
+             surf%uvw_abs(m) = SQRT( u_i**2 + v_i**2 + w_i**2 ) 
+          ENDDO
+       ENDIF            
+
+    END SUBROUTINE calc_uvw_abs_v_wgrid
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Compute the absolute value of the horizontal velocity (relative to the
+!> surface) for horizontal surface elements. This is required by all methods.
+!------------------------------------------------------------------------------!
+    SUBROUTINE calc_uvw_abs_v_sgrid
+
+       IMPLICIT NONE
+
+       INTEGER(iwp) ::  i             !< running index x direction
+       INTEGER(iwp) ::  j             !< running index y direction
+       INTEGER(iwp) ::  k             !< running index z direction
+       INTEGER(iwp) ::  m             !< running index surface elements
+
+       REAL(wp)     ::  u_i
+       REAL(wp)     ::  v_i
+       REAL(wp)     ::  w_i
+
+!
+!--    North- (l=0) and south-facing (l=1) walls 
+       IF ( l == 0  .OR.  l == 1 )  THEN
+          DO  m = 1, surf%ns
+             i   = surf%i(m)            
+             j   = surf%j(m)
+             k   = surf%k(m)
+
+             u_i = 0.5_wp * ( u(k,j,i) + u(k,j,i+1) )
+             v_i = 0.0_wp
+             w_i = 0.5_wp * ( w(k,j,i) + w(k-1,j,i) )
+
+             surf%uvw_abs(m) = SQRT( u_i**2 + v_i**2 + w_i**2 ) 
+          ENDDO
+!
+!--    East- (l=2) and west-facing (l=3) walls 
+       ELSE
+          DO  m = 1, surf%ns
+             i   = surf%i(m)            
+             j   = surf%j(m)
+             k   = surf%k(m)
+
+             u_i = 0.0_wp
+             v_i = 0.5_wp * ( v(k,j,i) + v(k,j+1,i) )
+             w_i = 0.5_wp * ( w(k,j,i) + w(k-1,j,i) )
+
+             surf%uvw_abs(m) = SQRT( u_i**2 + v_i**2 + w_i**2 ) 
+          ENDDO
+       ENDIF  
+
+    END SUBROUTINE calc_uvw_abs_v_sgrid
 
 
@@ -508,8 +1104,7 @@
        IMPLICIT NONE
 
-       INTEGER(iwp) :: iter,  & !< Newton iteration step
-                       l        !< look index
-
-       REAL(wp), DIMENSION(nysg:nyng,nxlg:nxrg) :: rib !< Bulk Richardson number
+       INTEGER(iwp) ::  iter    !< Newton iteration step
+       INTEGER(iwp) ::  li      !< look index
+       INTEGER(iwp) ::  m       !< loop variable over all horizontal wall elements 
 
        REAL(wp)     :: f,      & !< Function for Newton iteration: f = Ri - [...]/[...]^2 = 0
@@ -521,46 +1116,75 @@
 
        IF ( TRIM( most_method ) /= 'circular' )  THEN
-      
-          !$OMP PARALLEL DO PRIVATE( k, z_mo )
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-
-                k   = nzb_s_inner(j,i)
-                z_mo = zu(k+1) - zw(k)
-
-!
-!--             Evaluate bulk Richardson number (calculation depends on
-!--             definition based on setting of boundary conditions
-                IF ( ibc_pt_b /= 1 )  THEN
-                   IF ( humidity )  THEN
-                      rib(j,i) = g * z_mo * ( vpt(k+1,j,i) - vpt(k,j,i) )      &
-                           / ( uv_total(j,i)**2 * vpt(k+1,j,i) + 1.0E-20_wp )
-                   ELSE
-                      rib(j,i) = g * z_mo * ( pt(k+1,j,i) - pt(k,j,i) )        &
-                           / ( uv_total(j,i)**2 * pt(k+1,j,i)  + 1.0E-20_wp )
-                   ENDIF      
-                ELSE
-!
-!--                When using Neumann boundary conditions, the buoyancy flux
-!--                is required but cannot be calculated at the surface, as pt
-!--                and q are not known at the surface. Hence the values at 
-!--                first grid level are used to estimate the buoyancy flux
-                   IF ( humidity )  THEN
-                      rib(j,i) = - g * z_mo * ( ( 1.0_wp + 0.61_wp             &
-                                 * q(k+1,j,i) ) * shf(j,i) + 0.61_wp           &
-                                 * pt(k+1,j,i) * qsws(j,i) ) * drho_air_zw(k)  &
-                                 / ( uv_total(j,i)**3 * vpt(k+1,j,i) * kappa**2&
-                                 + 1.0E-20_wp)
-                   ELSE
-                      rib(j,i) = - g * z_mo * shf(j,i) * drho_air_zw(k)        &
-                           / ( uv_total(j,i)**3 * pt(k+1,j,i) * kappa**2       &
+!
+!--       Evaluate bulk Richardson number (calculation depends on
+!--       definition based on setting of boundary conditions
+          IF ( ibc_pt_b /= 1 )  THEN
+             IF ( humidity )  THEN
+                !$OMP PARALLEL DO PRIVATE( i, j, k, z_mo )
+                DO  m = 1, surf%ns
+
+                   i   = surf%i(m)            
+                   j   = surf%j(m)
+                   k   = surf%k(m)
+
+                   z_mo = surf%z_mo(m)
+
+                   surf%rib(m) = g * z_mo *                                    &
+                                         ( vpt(k,j,i) - vpt(k-1,j,i) ) /       &
+                      ( surf%uvw_abs(m)**2 * vpt(k,j,i) + 1.0E-20_wp )
+                ENDDO
+             ELSE
+                !$OMP PARALLEL DO PRIVATE( i, j, k, z_mo )
+                DO  m = 1, surf%ns
+
+                   i   = surf%i(m)            
+                   j   = surf%j(m)
+                   k   = surf%k(m)
+
+                   z_mo = surf%z_mo(m)
+
+                   surf%rib(m) = g * z_mo *                                    &
+                                         ( pt(k,j,i) - pt(k-1,j,i)   ) /       &
+                      ( surf%uvw_abs(m)**2 * pt(k,j,i)  + 1.0E-20_wp )
+                ENDDO
+             ENDIF
+          ELSE
+             IF ( humidity )  THEN
+                !$OMP PARALLEL DO PRIVATE( i, j, k, z_mo )
+                DO  m = 1, surf%ns
+
+                   i   = surf%i(m)            
+                   j   = surf%j(m)
+                   k   = surf%k(m)
+
+                   z_mo = surf%z_mo(m)
+
+                   surf%rib(m) = - g * z_mo * ( ( 1.0_wp + 0.61_wp             &
+                           * q(k,j,i) ) * surf%shf(m) + 0.61_wp                &
+                           * pt(k,j,i) * surf%qsws(m) ) *                      &
+                             drho_air_zw(k-1)                /                 &
+                         ( surf%uvw_abs(m)**3 * vpt(k,j,i) * kappa**2          &
                            + 1.0E-20_wp )
-                   ENDIF
-                ENDIF  
-     
-             ENDDO
-          ENDDO 
+                ENDDO
+             ELSE
+                !$OMP PARALLEL DO PRIVATE( i, j, k, z_mo )
+                DO  m = 1, surf%ns
+
+                   i   = surf%i(m)            
+                   j   = surf%j(m)
+                   k   = surf%k(m)
+
+                   z_mo = surf%z_mo(m)
+
+                   surf%rib(m) = - g * z_mo * surf%shf(m) *                    &
+                                        drho_air_zw(k-1)            /          &
+                        ( surf%uvw_abs(m)**3 * pt(k,j,i) * kappa**2            &
+                           + 1.0E-20_wp )
+                ENDDO
+             ENDIF
+          ENDIF
 
        ENDIF
+
 
 !
